Subject: [tsvwg] Technical discussion 4 of draft-ietf-tsvwg-aqm-dualq-coupled-08

From: David Pullen <[email-masked]>
Date: Mon, 17 Dec 2018 14:14:59 -0500

Hi Bob,

In section 2.5.2:

Total packets arriving, enqueued and dequeued to distinguish tail discard
from proactive AQM discard;

It isn't clear to me how one distinguishes between tail discard and AQM
discard with these counters.

If a packet is tail discarded, is "packets arriving" incremented? Or do the
counters not get incremented at all for tail discard?

If a packet is AQM discarded, are "packets arriving" and "packets enqueued"
incremented?

Some AQM implementations may implement AQM discard at the head of the
queue, and others may implement AQM discard at the tail of the queue. The
counters should be defined such that any differences in implementation
still yield the same results in terms of counter state.

Thanks,
  - Dave

David Pullen
Distinguished Engineer  |  Wired Networking, Cable Modems
Broadcom

office: 678.475.3143  |  mobile: 678.477.4108  |  fax: 770.232.0211
4385 River Green Parkway  |  Duluth, GA 30096
[email-masked]   |   broadcom.com

---

From: David Pullen <[email-masked]>
Date: Mon, 17 Dec 2018 14:23:41 -0500

Also, please note that this is my final technical comment.

Thanks,
  - Dave

David Pullen

On Mon, Dec 17, 2018 at 2:14 PM David Pullen <[email-masked]>
wrote:

> If a packet is tail discarded, is "packets arriving" incremented? Or do
> the counters not get incremented at all for tail discard?
>
> If a packet is AQM discarded, are "packets arriving" and "packets
> enqueued" incremented?
>

---

From: Bob Briscoe <[email-masked]>
Date: Fri, 21 Dec 2018 18:19:46 +0000

David,

You're right that our terminology is sloppy here. I've changed it to:

    Total packets arriving, processed by the AQM (after any tail-drop
    due to buffer overflow) and dequeued. The difference between the
    first two will measure any non-AQM tail discard. The difference
    between the last two will measure proactive AQM discard.

So yes, packets arriving is the only counter to be incremented if a 
packet is tail discarded due to buffer overflow.
And yes, if the AQM discards a packet, only packets dequeued is not 
incremented.
And I believe the above wording is now independent of whether the AQM is 
implemented at the tail or the head.

Given this is a SHOULD, an implementer could choose to record any 
combination that allows the same metrics to be reconstructed. E.g. 
packets arriving, packets tail-dropped due to buffer overflow and packet 
discarded by the AQM.

Bob

On 17/12/2018 19:14, David Pullen wrote:
> Hi Bob,
>
> In section 2.5.2:
>
> Total packets arriving, enqueued and dequeued to distinguish tail 
> discard from proactive AQM discard;
>
>
> It isn't clear to me how one distinguishes between tail discard and 
> AQM discard with these counters.
>
> If a packet is tail discarded, is "packets arriving" incremented? Or 
> do the counters not get incremented at all for tail discard?
>
> queue, and others may implement AQM discard at the tail of the queue. 
> The counters should be defined such that any differences in 
> implementation still yield the same results in terms of counter state.
>
> Thanks,
>   - Dave
>
> David PullenDistinguished Engineer  |  Wired Networking, Cable 
> ModemsBroadcomoffice:678.475.3143  | mobile:678.477.4108  | 
> fax:770.232.02114385 River Green Parkway  |  Duluth, GA 
> [email-masked] <mailto:[email-masked]>   | 
> broadcom.com <http://broadcom.com>
>

-- 
________________________________________________________________
Bob Briscoe                               http://bobbriscoe.net/